﻿using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
using AddinExpress.MSO;
using Word = Microsoft.Office.Interop.Word;

namespace WordUI
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("6DE35550-F871-4C93-92CC-F41F733CBECF"), ProgId("WordUI.AddinModule")]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule()
        {
            Application.EnableVisualStyles();
            InitializeComponent();
            // Please add any initialization code to the AddinInitialize event handler
        }

        private ADXMainMenu customMainMenu;
        private ADXCommandBarPopup adxCommandBarPopup1;
        private ADXCommandBarButton adxCommandBarButton1;
        private ADXCommandBarButton adxCommandBarButton2;
        private ADXCommandBarPopup adxCommandBarPopup2;
        private ADXCommandBarPopup adxCommandBarPopup3;
        private ADXCommandBarButton adxCommandBarButton3;
        private ADXCommandBarButton adxCommandBarButton4;
        private ADXContextMenu adxContextMenu1;
        private ADXCommandBarPopup adxCommandBarPopup4;
        private ADXCommandBarButton adxCommandBarButton5;
        private ADXCommandBarButton adxCommandBarButton6;
        private ADXBackstageView adxBackstageView1;
        private ADXBackstageTab adxBackstageTab1;
        private ADXBackstageGroup adxBackstageGroup2;
        private ADXBackstageHyperlink adxBackstageHyperlink1;
        private ADXBackstageGroupButton adxBackstageGroupButton1;
        private ADXBackstageTaskGroup adxBackstageTaskGroup2;
        private ADXBackstageTaskGroupCategory adxBackstageTaskGroupCategory1;
        private ADXBackstageTaskGroupTask adxBackstageTaskGroupTask1;
        private ADXBackstageTaskGroupCategory adxBackstageTaskGroupCategory2;
        private ADXBackstageTaskGroupTask adxBackstageTaskGroupTask2;
        private ADXBackstageGroup adxBackstageGroup1;
        private ADXBackstageLabelControl adxBackstageLabelControl1;
        private ADXBackstageRegularButton adxBackstageRegularButton1;
        private ImageList imlIcons;
        private ADXRibbonContextMenu adxRibbonContextMenu1;
        private ADXRibbonSplitButton adxRibbonSplitButton1;
        private ADXRibbonMenu adxRibbonMenu1;
        private ADXRibbonMenu adxRibbonMenu2;
        private ADXRibbonMenu adxRibbonMenu3;

        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;

        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(AddinModule));
            this.customMainMenu = new AddinExpress.MSO.ADXMainMenu(this.components);
            this.adxCommandBarPopup1 = new AddinExpress.MSO.ADXCommandBarPopup(this.components);
            this.adxCommandBarButton1 = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.adxCommandBarButton2 = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.adxCommandBarPopup2 = new AddinExpress.MSO.ADXCommandBarPopup(this.components);
            this.adxCommandBarPopup3 = new AddinExpress.MSO.ADXCommandBarPopup(this.components);
            this.adxCommandBarButton3 = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.adxCommandBarButton4 = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.adxContextMenu1 = new AddinExpress.MSO.ADXContextMenu(this.components);
            this.adxCommandBarPopup4 = new AddinExpress.MSO.ADXCommandBarPopup(this.components);
            this.adxCommandBarButton5 = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.adxCommandBarButton6 = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.adxBackstageView1 = new AddinExpress.MSO.ADXBackstageView(this.components);
            this.adxBackstageTab1 = new AddinExpress.MSO.ADXBackstageTab(this.components);
            this.adxBackstageGroup2 = new AddinExpress.MSO.ADXBackstageGroup(this.components);
            this.adxBackstageRegularButton1 = new AddinExpress.MSO.ADXBackstageRegularButton(this.components);
            this.imlIcons = new System.Windows.Forms.ImageList(this.components);
            this.adxBackstageGroupButton1 = new AddinExpress.MSO.ADXBackstageGroupButton(this.components);
            this.adxBackstageHyperlink1 = new AddinExpress.MSO.ADXBackstageHyperlink(this.components);
            this.adxBackstageTaskGroup2 = new AddinExpress.MSO.ADXBackstageTaskGroup(this.components);
            this.adxBackstageTaskGroupCategory1 = new AddinExpress.MSO.ADXBackstageTaskGroupCategory(this.components);
            this.adxBackstageTaskGroupTask1 = new AddinExpress.MSO.ADXBackstageTaskGroupTask(this.components);
            this.adxBackstageTaskGroupCategory2 = new AddinExpress.MSO.ADXBackstageTaskGroupCategory(this.components);
            this.adxBackstageTaskGroupTask2 = new AddinExpress.MSO.ADXBackstageTaskGroupTask(this.components);
            this.adxBackstageGroup1 = new AddinExpress.MSO.ADXBackstageGroup(this.components);
            this.adxBackstageLabelControl1 = new AddinExpress.MSO.ADXBackstageLabelControl(this.components);
            this.adxRibbonContextMenu1 = new AddinExpress.MSO.ADXRibbonContextMenu(this.components);
            this.adxRibbonSplitButton1 = new AddinExpress.MSO.ADXRibbonSplitButton(this.components);
            this.adxRibbonMenu1 = new AddinExpress.MSO.ADXRibbonMenu(this.components);
            this.adxRibbonMenu2 = new AddinExpress.MSO.ADXRibbonMenu(this.components);
            this.adxRibbonMenu3 = new AddinExpress.MSO.ADXRibbonMenu(this.components);
            // 
            // customMainMenu
            // 
            this.customMainMenu.CommandBarName = "Menu Bar";
            this.customMainMenu.CommandBarTag = "52aeed32-8b28-4077-887f-0f5fb6011b0b";
            this.customMainMenu.Controls.Add(this.adxCommandBarPopup1);
            this.customMainMenu.Controls.Add(this.adxCommandBarPopup2);
            this.customMainMenu.SupportedApp = AddinExpress.MSO.ADXOfficeHostApp.ohaWord;
            this.customMainMenu.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaWord;
            this.customMainMenu.UpdateCounter = 15;
            // 
            // adxCommandBarPopup1
            // 
            this.adxCommandBarPopup1.BeforeID = 30003;
            this.adxCommandBarPopup1.Caption = "Publish";
            this.adxCommandBarPopup1.Controls.Add(this.adxCommandBarButton1);
            this.adxCommandBarPopup1.Controls.Add(this.adxCommandBarButton2);
            this.adxCommandBarPopup1.ControlTag = "d34666c4-4d9c-4f59-8a5d-d65de34dee94";
            this.adxCommandBarPopup1.UpdateCounter = 2;
            // 
            // adxCommandBarButton1
            // 
            this.adxCommandBarButton1.Caption = "To Intranet";
            this.adxCommandBarButton1.ControlTag = "2406a13b-0272-4fcd-bca9-f35e375e5954";
            this.adxCommandBarButton1.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxCommandBarButton1.UpdateCounter = 1;
            // 
            // adxCommandBarButton2
            // 
            this.adxCommandBarButton2.Caption = "To Internet";
            this.adxCommandBarButton2.ControlTag = "1a951a50-c488-495b-b260-aff27e775b89";
            this.adxCommandBarButton2.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxCommandBarButton2.UpdateCounter = 1;
            // 
            // adxCommandBarPopup2
            // 
            this.adxCommandBarPopup2.Caption = "File";
            this.adxCommandBarPopup2.Controls.Add(this.adxCommandBarPopup3);
            this.adxCommandBarPopup2.ControlTag = "f13bd655-c9b8-4ab1-b61f-803b52eb3b05";
            this.adxCommandBarPopup2.Id = 30002;
            this.adxCommandBarPopup2.UpdateCounter = 2;
            // 
            // adxCommandBarPopup3
            // 
            this.adxCommandBarPopup3.BeforeID = 30095;
            this.adxCommandBarPopup3.Caption = "Share With";
            this.adxCommandBarPopup3.Controls.Add(this.adxCommandBarButton3);
            this.adxCommandBarPopup3.Controls.Add(this.adxCommandBarButton4);
            this.adxCommandBarPopup3.ControlTag = "3b1f81a5-7783-4cb7-8b6e-44c78d44e9f4";
            this.adxCommandBarPopup3.UpdateCounter = 2;
            // 
            // adxCommandBarButton3
            // 
            this.adxCommandBarButton3.Caption = "Twitter";
            this.adxCommandBarButton3.ControlTag = "0fec22f0-6390-4062-b8d1-ea2b6d6b6474";
            this.adxCommandBarButton3.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxCommandBarButton3.UpdateCounter = 1;
            // 
            // adxCommandBarButton4
            // 
            this.adxCommandBarButton4.Caption = "Facebook";
            this.adxCommandBarButton4.ControlTag = "ffa0c491-3c84-4638-b6e5-e9ae6ba1a4ef";
            this.adxCommandBarButton4.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxCommandBarButton4.UpdateCounter = 1;
            // 
            // adxContextMenu1
            // 
            this.adxContextMenu1.CommandBarName = "Inline Picture";
            this.adxContextMenu1.CommandBarTag = "a0205702-3f6f-47fa-999d-450bdbebd375";
            this.adxContextMenu1.Controls.Add(this.adxCommandBarPopup4);
            this.adxContextMenu1.SupportedApp = AddinExpress.MSO.ADXOfficeHostApp.ohaWord;
            this.adxContextMenu1.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaWord;
            this.adxContextMenu1.Temporary = true;
            this.adxContextMenu1.UpdateCounter = 13;
            // 
            // adxCommandBarPopup4
            // 
            this.adxCommandBarPopup4.Caption = "Optimize && Fix";
            this.adxCommandBarPopup4.Controls.Add(this.adxCommandBarButton5);
            this.adxCommandBarPopup4.Controls.Add(this.adxCommandBarButton6);
            this.adxCommandBarPopup4.ControlTag = "d6e2f6d1-88cf-48ab-a5ae-52d1249fa8a9";
            this.adxCommandBarPopup4.Temporary = true;
            this.adxCommandBarPopup4.UpdateCounter = 2;
            // 
            // adxCommandBarButton5
            // 
            this.adxCommandBarButton5.Caption = "Auto-Correct";
            this.adxCommandBarButton5.ControlTag = "ff05ed70-f36e-4500-a9bf-62ca467728ff";
            this.adxCommandBarButton5.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxCommandBarButton5.Temporary = true;
            this.adxCommandBarButton5.UpdateCounter = 1;
            // 
            // adxCommandBarButton6
            // 
            this.adxCommandBarButton6.Caption = "Optimize for the web";
            this.adxCommandBarButton6.ControlTag = "7206a619-2933-4cc3-80eb-b776848f0898";
            this.adxCommandBarButton6.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxCommandBarButton6.Temporary = true;
            this.adxCommandBarButton6.UpdateCounter = 1;
            // 
            // adxBackstageView1
            // 
            this.adxBackstageView1.Controls.Add(this.adxBackstageTab1);
            this.adxBackstageView1.Id = "adxBackstageView_0f6d9b8e0ee342cc9967525a3f666530";
            this.adxBackstageView1.Ribbons = AddinExpress.MSO.ADXRibbons.msrWordDocument;
            // 
            // adxBackstageTab1
            // 
            this.adxBackstageTab1.Caption = "Share With";
            this.adxBackstageTab1.FirstColumn.Add(this.adxBackstageGroup2);
            this.adxBackstageTab1.FirstColumn.Add(this.adxBackstageTaskGroup2);
            this.adxBackstageTab1.Id = "adxBackstageTab_2541a27f932448649e754d01f0d90b6c";
            this.adxBackstageTab1.Ribbons = AddinExpress.MSO.ADXRibbons.msrWordDocument;
            this.adxBackstageTab1.SecondColumn.Add(this.adxBackstageGroup1);
            // 
            // adxBackstageGroup2
            // 
            this.adxBackstageGroup2.Caption = "Twitter";
            this.adxBackstageGroup2.Id = "adxBackstageGroup_856fd1662c154cadb5ba4283c4c586fd";
            this.adxBackstageGroup2.PrimaryItem.Add(this.adxBackstageRegularButton1);
            this.adxBackstageGroup2.Ribbons = AddinExpress.MSO.ADXRibbons.msrWordDocument;
            this.adxBackstageGroup2.TopItems.Add(this.adxBackstageGroupButton1);
            this.adxBackstageGroup2.TopItems.Add(this.adxBackstageHyperlink1);
            // 
            // adxBackstageRegularButton1
            // 
            this.adxBackstageRegularButton1.Caption = "Send Now";
            this.adxBackstageRegularButton1.Id = "adxBackstageRegularButton_61941ecf7c2f4e6f8ecc7e895d8b0a5c";
            this.adxBackstageRegularButton1.Image = 2;
            this.adxBackstageRegularButton1.ImageList = this.imlIcons;
            this.adxBackstageRegularButton1.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxBackstageRegularButton1.Ribbons = AddinExpress.MSO.ADXRibbons.msrWordDocument;
            // 
            // imlIcons
            // 
            this.imlIcons.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imlIcons.ImageStream")));
            this.imlIcons.TransparentColor = System.Drawing.Color.Transparent;
            this.imlIcons.Images.SetKeyName(0, "comment_facebook_box.png");
            this.imlIcons.Images.SetKeyName(1, "facebook.png");
            this.imlIcons.Images.SetKeyName(2, "twitter_1.png");
            // 
            // adxBackstageGroupButton1
            // 
            this.adxBackstageGroupButton1.Caption = "Options";
            this.adxBackstageGroupButton1.Id = "adxBackstageGroupButton_f2b4bee007ae47dc883501d4eb4b3d0c";
            this.adxBackstageGroupButton1.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxBackstageGroupButton1.Ribbons = AddinExpress.MSO.ADXRibbons.msrWordDocument;
            // 
            // adxBackstageHyperlink1
            // 
            this.adxBackstageHyperlink1.Caption = "Visit Site";
            this.adxBackstageHyperlink1.Id = "adxBackstageHyperlink_14cee3dd0dda43e7994de12ece63bb2b";
            this.adxBackstageHyperlink1.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxBackstageHyperlink1.Ribbons = AddinExpress.MSO.ADXRibbons.msrWordDocument;
            // 
            // adxBackstageTaskGroup2
            // 
            this.adxBackstageTaskGroup2.Caption = "Facebook";
            this.adxBackstageTaskGroup2.Controls.Add(this.adxBackstageTaskGroupCategory1);
            this.adxBackstageTaskGroup2.Controls.Add(this.adxBackstageTaskGroupCategory2);
            this.adxBackstageTaskGroup2.Id = "adxBackstageTaskGroup_597ed97c84f5491da626fa8ff73037d2";
            this.adxBackstageTaskGroup2.Ribbons = AddinExpress.MSO.ADXRibbons.msrWordDocument;
            // 
            // adxBackstageTaskGroupCategory1
            // 
            this.adxBackstageTaskGroupCategory1.Caption = "Timeline";
            this.adxBackstageTaskGroupCategory1.Controls.Add(this.adxBackstageTaskGroupTask1);
            this.adxBackstageTaskGroupCategory1.Id = "adxBackstageTaskGroupCategory_fe2f5e051efc478ca630cd3da65a8f9b";
            this.adxBackstageTaskGroupCategory1.Ribbons = AddinExpress.MSO.ADXRibbons.msrWordDocument;
            // 
            // adxBackstageTaskGroupTask1
            // 
            this.adxBackstageTaskGroupTask1.Caption = "Send to Timeline";
            this.adxBackstageTaskGroupTask1.Id = "adxBackstageTaskGroupTask_22fb4756efcd4618a62b9f29e0907dcb";
            this.adxBackstageTaskGroupTask1.Image = 0;
            this.adxBackstageTaskGroupTask1.ImageList = this.imlIcons;
            this.adxBackstageTaskGroupTask1.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxBackstageTaskGroupTask1.Ribbons = AddinExpress.MSO.ADXRibbons.msrWordDocument;
            // 
            // adxBackstageTaskGroupCategory2
            // 
            this.adxBackstageTaskGroupCategory2.Caption = "Status Message";
            this.adxBackstageTaskGroupCategory2.Controls.Add(this.adxBackstageTaskGroupTask2);
            this.adxBackstageTaskGroupCategory2.Id = "adxBackstageTaskGroupCategory_ddd69eef89834f1fae041efaafcd4875";
            this.adxBackstageTaskGroupCategory2.Ribbons = AddinExpress.MSO.ADXRibbons.msrWordDocument;
            // 
            // adxBackstageTaskGroupTask2
            // 
            this.adxBackstageTaskGroupTask2.Caption = "Set as my Status";
            this.adxBackstageTaskGroupTask2.Id = "adxBackstageTaskGroupTask_2b1e26a364bf470caae7d4e110db5f17";
            this.adxBackstageTaskGroupTask2.Image = 1;
            this.adxBackstageTaskGroupTask2.ImageList = this.imlIcons;
            this.adxBackstageTaskGroupTask2.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxBackstageTaskGroupTask2.Ribbons = AddinExpress.MSO.ADXRibbons.msrWordDocument;
            // 
            // adxBackstageGroup1
            // 
            this.adxBackstageGroup1.Caption = "About";
            this.adxBackstageGroup1.Id = "adxBackstageGroup_e902f6c5c166434b9c5f0cf956035f70";
            this.adxBackstageGroup1.Ribbons = AddinExpress.MSO.ADXRibbons.msrWordDocument;
            this.adxBackstageGroup1.TopItems.Add(this.adxBackstageLabelControl1);
            // 
            // adxBackstageLabelControl1
            // 
            this.adxBackstageLabelControl1.Caption = "This add-in makes it easy to publish to your social media accounts";
            this.adxBackstageLabelControl1.Id = "adxBackstageLabelControl_fb164398a6494932bda479297b3300a5";
            this.adxBackstageLabelControl1.Ribbons = AddinExpress.MSO.ADXRibbons.msrWordDocument;
            // 
            // adxRibbonContextMenu1
            // 
            this.adxRibbonContextMenu1.ContextMenuNames.AddRange(new string[] {
            "Word.ContextMenuPicture"});
            this.adxRibbonContextMenu1.Controls.Add(this.adxRibbonSplitButton1);
            this.adxRibbonContextMenu1.Ribbons = AddinExpress.MSO.ADXRibbons.msrWordDocument;
            // 
            // adxRibbonSplitButton1
            // 
            this.adxRibbonSplitButton1.Caption = "Optimize & Fix";
            this.adxRibbonSplitButton1.Controls.Add(this.adxRibbonMenu1);
            this.adxRibbonSplitButton1.Id = "adxRibbonSplitButton_a52a24b675b5453daca2ad0eb9b9126b";
            this.adxRibbonSplitButton1.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonSplitButton1.Ribbons = AddinExpress.MSO.ADXRibbons.msrWordDocument;
            // 
            // adxRibbonMenu1
            // 
            this.adxRibbonMenu1.Caption = "adxRibbonMenu1";
            this.adxRibbonMenu1.Controls.Add(this.adxRibbonMenu2);
            this.adxRibbonMenu1.Controls.Add(this.adxRibbonMenu3);
            this.adxRibbonMenu1.Id = "adxRibbonMenu_43cf311020864e349224503283ab0eeb";
            this.adxRibbonMenu1.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonMenu1.Ribbons = AddinExpress.MSO.ADXRibbons.msrWordDocument;
            // 
            // adxRibbonMenu2
            // 
            this.adxRibbonMenu2.Caption = "Auto-Correct";
            this.adxRibbonMenu2.Id = "adxRibbonMenu_031818177fd94559987f22c0724f1ed2";
            this.adxRibbonMenu2.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonMenu2.Ribbons = AddinExpress.MSO.ADXRibbons.msrWordDocument;
            // 
            // adxRibbonMenu3
            // 
            this.adxRibbonMenu3.Caption = "Optimize for Web";
            this.adxRibbonMenu3.Id = "adxRibbonMenu_272f777b027c488dbc4eec2ae487dc8c";
            this.adxRibbonMenu3.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonMenu3.Ribbons = AddinExpress.MSO.ADXRibbons.msrWordDocument;
            // 
            // AddinModule
            // 
            this.AddinName = "WordUI";
            this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaWord;
            this.AddinInitialize += new AddinExpress.MSO.ADXEvents_EventHandler(this.AddinModule_AddinInitialize);

        }
        #endregion

        #region Add-in Express automatic code

        // Required by Add-in Express - do not modify
        // the methods within this region

        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }

        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }

        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }

        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

        public static new AddinModule CurrentInstance
        {
            get
            {
                return AddinExpress.MSO.ADXAddinModule.CurrentInstance as AddinModule;
            }
        }

        public Word._Application WordApp
        {
            get
            {
                return (HostApplication as Word._Application);
            }
        }

        private void AddinModule_AddinInitialize(object sender, EventArgs e)
        {
            if (this.HostMajorVersion >= 14)
                adxContextMenu1.UseForRibbon = false;
        }
    }
}

